﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using InvokeSolutions.Xlsx.Data;
using InvokeSolutions.Xlsx;
using System.Diagnostics;

namespace zSample.DoubleExtendingColumns
{
    class Program
    {
        static void Main(string[] args)
        {
            File.Copy("template.xlsx", "report.xlsx", true);

            DocumentDataSource dds = new DocumentDataSource();

            dds["DATE"] = DateTime.Today.ToShortDateString();
            dds["CUSTOMER"] = "Little Pony Ltd.";
            dds["INVOICE_NUMBER"] = "666";

            dds["R"] =
                DataItem.ConvertFrom(
                new[] {
                        new { Currency = "USD", Rate = 1.46},
                        new { Currency = "EUR", Rate = 1.78},
                        new { Currency = "GBP", Rate = 2.14},
                    }
                );

            dds["H"] = DataItem.ConvertFrom(
                   new[] { 
                        new { Title = "Qty1", Value = "%T.QTY1%" },
                        new { Title = "Qty2", Value = "%T.QTY2%" }
                   }
                );

            dds["G"] = DataItem.ConvertFrom(
                new[] { 
                        new { Title = "Qty3", Value = "%T.QTY3%" },
                        new { Title = "Qty4", Value = "%T.QTY4%" }
                   }
                );

            dds["T"] = DataItem.ConvertFrom(
                new[]{
                    new { Title = "Borat: Cultural Learnings of America for Make Benefit Glorious Nation of Kazakhstan", Qty = 1, Ppi = 100.00, Gst = 12.5m, Total = 112.50, Qty1 = 1, Qty2 = new FormulaDataItem("=[Qty1]*[Qty1]")},
                    new { Title = "Brüno", Qty = 10, Ppi = 50.00, Gst = 62.5m, Total = 562.50, Qty1 = 2, Qty2 = new FormulaDataItem("=[Qty1]*[Qty1]")},
                    new { Title = "Self-control when learning xlsx format", Qty = 50, Ppi = 50.00, Gst = 62.5m, Total = 562.50, Qty1 = 3, Qty2 = new FormulaDataItem("=[Qty1]*[Qty1]")}
                });

            XlsxRenderer.RenderDocument("report.xlsx", dds);

            Process.Start("report.xlsx");

        }
    }
}
